=== debian/changelog ===
frozen (1.1.1-3) unstable; urgency=medium

  * debian/patches/no-werror.diff: don't use -Werror
  * debian/patches/cstdint.diff: add missing #include <cstdint> to fix
    build of the tests with gcc 13 

 -- Rene Engelhard <rene@debian.org>  Mon, 24 Jul 2023 22:02:12 +0000

frozen (1.1.1-2) unstable; urgency=medium

  * source-only upload to allow testing migration 

 -- Rene Engelhard <rene@debian.org>  Mon, 24 Jul 2023 19:19:38 +0000

frozen (1.1.1-1) unstable; urgency=medium

  * Initial release.

 -- Rene Engelhard <rene@debian.org>  Sat, 17 Jun 2023 19:36:24 +0000
