## frozen 1.2.0

=== debian/changelog ===
frozen (1.2.0-2) unstable; urgency=medium

  * upload to unstable 

 -- Rene Engelhard <rene@debian.org>  Sat, 21 Sep 2024 20:39:34 +0200

frozen (1.2.0-1) experimental; urgency=medium

  * New upstream release.

 -- Rene Engelhard <rene@debian.org>  Fri, 30 Aug 2024 20:14:35 +0200
